package org.jcg.zheng;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNull;

import java.util.Arrays;

import org.junit.Test;

// since Java 1.6
public class Arrays_copyOfRangeTest extends TestBase {

    @Test
    public void copy_IntArray() {
        int[] copyofArr = Arrays.copyOfRange(sourceIntegerArray, copyStartAtZeroIndex,
                sourceIntegerArray.length);

        assertEquals(sourceIntegerArray.length, copyofArr.length);
        assertEquals(sourceIntegerArray[0], copyofArr[0]);
        assertEquals(sourceIntegerArray[1], copyofArr[1]);
        validate_IntArray(copyofArr);
    }

    @Test
    public void copy_StringArray() {
        String[] copyofArr = Arrays.copyOfRange(sourceStringArray, copyStartAtZeroIndex,
                sourceStringArray.length - 1);

        assertEquals(sourceStringArray.length - 1, copyofArr.length);
        assertEquals(sourceStringArray[0], copyofArr[0]);
        assertEquals(sourceStringArray[1], copyofArr[1]);

        validate_StringArray(copyofArr);
    }

    @Test
    public void copy_ObjectArray() {
        DemoObject[] clonedArray = Arrays.copyOfRange(sourceObjectArray, copyStartAtZeroIndex,
                sourceIntegerArray.length - 1);

        assertEquals(sourceIntegerArray.length - 1, clonedArray.length);
        validate_shallowCopy_ObjectArray(clonedArray);
    }

    @Test
    public void padding_null_when_dest_is_larger_then_original() {
        DemoObject[] clonedArray = Arrays.copyOfRange(sourceObjectArray, copyStartAtZeroIndex,
                sourceObjectArray.length + 1);

        assertEquals(sourceObjectArray.length + 1, clonedArray.length);
        assertNull(clonedArray[sourceObjectArray.length]);
        validate_shallowCopy_ObjectArray(clonedArray);
    }
}