package org.jcg.zheng;

import static org.junit.Assert.assertEquals;

import java.util.Arrays;

import org.junit.Test;

// Since Java 1.6
public class Arrays_copyOfTest extends TestBase {

    @Test
    public void copy_IntArray() {
        int[] copyofArr = Arrays.copyOf(sourceIntegerArray, sourceIntegerArray.length);

        assertEquals(sourceIntegerArray.length, copyofArr.length);
        validate_IntArray(copyofArr);
    }

    @Test
    public void copy_IntArray_big() {
        int[] copyofArr = Arrays.copyOf(sourceIntegerArray, sourceIntegerArray.length + 1);

        assertEquals(sourceIntegerArray.length + 1, copyofArr.length);
        assertEquals(0, copyofArr[sourceIntegerArray.length]);
        validate_IntArray(copyofArr);
    }

    @Test
    public void copy_IntArray_small() {
        int[] copyofArr = Arrays.copyOf(sourceIntegerArray, sourceIntegerArray.length - 1);

        assertEquals(sourceIntegerArray.length - 1, copyofArr.length);

        validate_IntArray(copyofArr);
    }

    @Test
    public void copy_2D_IntArray() {
        int[][] clonedArray = source2DArray.clone();

        assertEquals(source2DArray.length, clonedArray.length);
        assertEquals(source2DArray[0][0], clonedArray[0][0]);
        assertEquals(source2DArray[0][1], clonedArray[0][1]);
        assertEquals(source2DArray[1][0], clonedArray[1][0]);
        assertEquals(source2DArray[1][1], clonedArray[1][1]);
    }

    @Test
    public void copy_StringArray() {
        String[] copyofArr = Arrays.copyOf(sourceStringArray, sourceStringArray.length - 1);

        assertEquals(sourceStringArray.length - 1, copyofArr.length);
        assertEquals(sourceStringArray[0], copyofArr[0]);
        assertEquals(sourceStringArray[1], copyofArr[1]);

        validate_StringArray(copyofArr);
    }

    @Test
    public void copy_ObjectArray() {
        DemoObject[] clonedArray = Arrays.copyOf(sourceObjectArray, sourceObjectArray.length);

        assertEquals(sourceObjectArray.length, clonedArray.length);
        validate_shallowCopy_ObjectArray(clonedArray);
    }
}