package org.jcg.zheng;

import static org.junit.Assert.assertEquals;

import java.util.Arrays;

import org.junit.Test;

// Since Java 1.8
public class Arrays_stream_toArrayTest extends TestBase {

    @Test
    public void copy_IntArray() {
        int[] copyofArr = Arrays.stream(sourceIntegerArray).toArray();

        assertEquals(sourceIntegerArray.length, copyofArr.length);
        assertEquals(1, sourceIntegerArray[0]);
        assertEquals(1, copyofArr[0]);

        validate_IntArray(copyofArr);
    }

    @Test
    public void copy_2D_IntArray_lambda() {
        int[][] clonedArray = Arrays.stream(source2DArray).map((int[] row) -> row.clone())
                .toArray((int length) -> new int[length][]);

        assertEquals(source2DArray.length, clonedArray.length);
        assertEquals(source2DArray[0][0], clonedArray[0][0]);
        assertEquals(source2DArray[0][1], clonedArray[0][1]);
        assertEquals(source2DArray[1][0], clonedArray[1][0]);
        assertEquals(source2DArray[1][1], clonedArray[1][1]);
    }

    @Test
    public void copy_2D_IntArray_methodReference() {
        int[][] clonedArray = Arrays.stream(source2DArray).map(int[]::clone).toArray(int[][]::new);

        assertEquals(source2DArray.length, clonedArray.length);
        assertEquals(source2DArray[0][0], clonedArray[0][0]);
        assertEquals(source2DArray[0][1], clonedArray[0][1]);
        assertEquals(source2DArray[1][0], clonedArray[1][0]);
        assertEquals(source2DArray[1][1], clonedArray[1][1]);
    }

    @Test
    public void copy_StringArray() {
        String[] copyofArr = Arrays.stream(sourceStringArray).toArray(String[]::new);

        assertEquals(sourceStringArray.length, copyofArr.length);
        assertEquals(sourceStringArray[0], copyofArr[0]);
        assertEquals(sourceStringArray[1], copyofArr[1]);

        validate_StringArray(copyofArr);
    }

    @Test
    public void copy_ObjectArray() {
        DemoObject[] clonedArray = Arrays.stream(sourceObjectArray).map(DemoObject::new)
                .toArray(DemoObject[]::new);

        validate_deepCopy_ObjectArray(clonedArray);
    }
}