package org.jcg.zheng;

import static org.junit.Assert.assertEquals;

import org.junit.Test;

// Since Java 1.0
public class Object_cloneTest extends TestBase {

    @Test
    public void copy_IntArray() {
        int[] clonedArray = sourceIntegerArray.clone();

        assertEquals(sourceIntegerArray.length, clonedArray.length);
        assertEquals(sourceIntegerArray[0], clonedArray[0]);
        assertEquals(sourceIntegerArray[1], clonedArray[1]);
        assertEquals(sourceIntegerArray[2], clonedArray[2]);

        validate_IntArray(clonedArray);
    }

    @Test
    public void copy_2D_IntArray() {
        int[][] clonedArray = source2DArray.clone();

        assertEquals(source2DArray.length, clonedArray.length);
        assertEquals(source2DArray[0][0], clonedArray[0][0]);
        assertEquals(source2DArray[0][1], clonedArray[0][1]);
        assertEquals(source2DArray[1][0], clonedArray[1][0]);
        assertEquals(source2DArray[1][1], clonedArray[1][1]);
    }

    @Test
    public void copy_StringArray() {
        String[] clonedArray = sourceStringArray.clone();

        assertEquals(sourceStringArray.length, clonedArray.length);
        assertEquals(sourceStringArray[0], clonedArray[0]);
        assertEquals(sourceStringArray[1], clonedArray[1]);

        validate_StringArray(clonedArray);
    }

    @Test
    public void copy_ObjectArray() {
        DemoObject[] clonedArray = sourceObjectArray.clone();

        assertEquals(sourceObjectArray.length, clonedArray.length);
        validate_shallowCopy_ObjectArray(clonedArray);
    }

}